package com.xydl.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.xydl.entity.I2relation;
import com.xydl.entity.SyncFieldsInfo;
import lombok.Data;

import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Data
public class AssetItem {
    @JsonProperty("AssetCode")
    String assetCode;
    @JsonProperty("AttributeList")
    List<AttributeItem> attributeList;
    @JsonProperty("Timestamp")
    Long timestamp;

    public static AssetItem fromData(Map<String, Object> map, String timeField,
                                     I2relation relation, List<SyncFieldsInfo> fieldList) {

        List<AttributeItem> list = new ArrayList<>();
        for (SyncFieldsInfo field : fieldList) {
            if (relation.getSensorindex().equals(field.getSensorindex())) {
                AttributeItem item = AttributeItem.fromData(map, field);
                if (item != null) {
                    list.add(item);
                }
            }
        }
        if (list.size() > 0) {
            AssetItem root = new AssetItem();
            root.setAssetCode(relation.getSensorid());
            root.setAttributeList(list);
            LocalDateTime time = (LocalDateTime) map.get(timeField);
            root.setTimestamp(time.atZone(ZoneId.systemDefault()).toInstant().toEpochMilli());
            return root;
        } else {
            return null;
        }
    }
}
