package com.xydl.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.xydl.entity.I2relation;
import com.xydl.entity.SyncFieldsInfo;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Data
public class AssetList {
    @JsonProperty("AssetList")
    List<AssetItem> assetList;

    public static AssetList fromData(List<Map<String, Object>> dataList, String timeField,
                                     List<I2relation> relationList, List<SyncFieldsInfo> fieldList) {

        List<AssetItem> list = new ArrayList<>();
        for (Map<String, Object> map : dataList) {
            for (I2relation relation : relationList) {
                AssetItem item = AssetItem.fromData(map, timeField, relation, fieldList);
                if (item != null) {
                    list.add(item);
                }
            }
        }
        if (list.size() > 0) {
            AssetList root = new AssetList();
            root.setAssetList(list);
            return root;
        } else {
            return null;
        }
    }
}
