package com.xydl.service;

import com.xydl.entity.SyncRecords;
import com.xydl.entity.SyncRecordsKey;
import com.xydl.repository.SyncRecordsRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Optional;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class SyncRecordsService {
    @Resource
    SyncRecordsRepository repository;

    public Optional<SyncRecords> findByKey(Integer clientId, String tableName, String devid) {
        SyncRecordsKey key = SyncRecordsKey.builder()
                .clientId(clientId)
                .tableName(tableName)
                .devidVal(devid)
                .build();
        return repository.findById(key);
    }

    public void update(SyncRecords record) {
        repository.save(record);
    }
}
